Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class DefaultListSelectionModel

    java.lang.Object
      |
      +--javax.swing.DefaultListSelectionModel

All Implemented Interfaces:
  Cloneable, ListSelectionModel, Serializable

public class DefaultListSelectionModel
extends Object
implements ListSelectionModel, Cloneable, Serializable

Default data model for list selections.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `ListSelectionModel`, Serialized Form

Field Summary
`protected boolean` | `leadAnchorNotificationEnabled`
`protected EventListenerList` | `listenerList`

Fields inherited from interface javax.swing.ListSelectionModel
`MULTIPLE_INTERVAL_SELECTION, SINGLE_INTERVAL_SELECTION, SINGLE_SELECTION`

Constructor Summary
`DefaultListSelectionModel()`

Method Summary
`void` | `addListSelectionListener(ListSelectionListener l)` Add a listener to the list that's notified each time a change to the selection occurs.
`void` | `addSelectionInterval(int index0, int index1)` Change the selection to be the set union of the current selection and the indices between index0 and index1 inclusive.
`void` | `clearSelection()` Change the selection to the empty set.
`Object` | `clone()` Returns a clone of this selection model with the same selection.
`protected void` | `fireValueChanged(boolean isAdjusting)` Notifies listeners that we have ended a series of adjustments.
`protected void` | `fireValueChanged(int firstIndex, int lastIndex)` Notifies `ListSelectionListeners` that the value of the selection, in the closed interval `firstIndex`, `lastIndex`, has changed.
`protected void` | `fireValueChanged(int firstIndex, int lastIndex, boolean isAdjusting)`
`int` | `getAnchorSelectionIndex()` Return the first index argument from the most recent call to setSelectionInterval(), addSelectionInterval() or removeSelectionInterval().
`int` | `getLeadSelectionIndex()` Return the second index argument from the most recent call to setSelectionInterval(), addSelectionInterval() or removeSelectionInterval().
`EventListener[]` | `getListeners(Class listenerType)` Returns an array of all the listeners of the given type that were added to this model.
`int` | `getMaxSelectionIndex()` Returns the last selected index or -1 if the selection is empty.
`int` | `getMinSelectionIndex()` Returns the first selected index or -1 if the selection is empty.
`int` | `getSelectionMode()` Returns the selection mode.
`boolean` | `getValueIsAdjusting()` Returns true if the value is undergoing a series of changes.
`void` | `insertIndexInterval(int index, int length, boolean before)` Insert length indices beginning before/after index.
`boolean` | `isLeadAnchorNotificationEnabled()` Returns the value of the `leadAnchorNotificationEnabled` flag.
`boolean` | `isSelectedIndex(int index)` Returns true if the specified index is selected.
`boolean` | `isSelectionEmpty()` Returns true if no indices are selected.
`void` | `removeIndexInterval(int index0, int index1)` Remove the indices in the interval index0,index1 (inclusive) from the selection model.
`void` | `removeListSelectionListener(ListSelectionListener l)` Remove a listener from the list that's notified each time a change to the selection occurs.
`void` | `removeSelectionInterval(int index0, int index1)` Change the selection to be the set difference of the current selection and the indices between index0 and index1 inclusive.
`void` | `setAnchorSelectionIndex(int anchorIndex)` Set the anchor selection index, leaving all selection values unchanged.
`void` | `setLeadAnchorNotificationEnabled(boolean flag)` Sets the value of the leadAnchorNotificationEnabled flag.
`void` | `setLeadSelectionIndex(int leadIndex)` Sets the lead selection index, ensuring that values between the anchor and the new lead are either all selected or all deselected.
`void` | `setSelectionInterval(int index0, int index1)` Change the selection to be between index0 and index1 inclusive.
`void` | `setSelectionMode(int selectionMode)` Sets the selection mode.
`void` | `setValueIsAdjusting(boolean isAdjusting)` This property is true if upcoming changes to the value of the model should be considered a single event.
`String` | `toString()` Returns a string that displays and identifies this object's properties.

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### listenerList

    protected EventListenerList listenerList

### leadAnchorNotificationEnabled

    protected boolean leadAnchorNotificationEnabled

Constructor Detail

### DefaultListSelectionModel

    public DefaultListSelectionModel()

Method Detail

### getMinSelectionIndex

    public int getMinSelectionIndex()

  Description copied from interface: `ListSelectionModel`
  Returns the first selected index or -1 if the selection is empty.
  Specified by:
    `getMinSelectionIndex` in interface `ListSelectionModel`

### getMaxSelectionIndex

    public int getMaxSelectionIndex()

  Description copied from interface: `ListSelectionModel`
  Returns the last selected index or -1 if the selection is empty.
  Specified by:
    `getMaxSelectionIndex` in interface `ListSelectionModel`

### getValueIsAdjusting

    public boolean getValueIsAdjusting()

  Description copied from interface: `ListSelectionModel`
  Returns true if the value is undergoing a series of changes.
  Specified by:
    `getValueIsAdjusting` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  Returns:
    true if the value is currently adjusting
  See Also:
    `ListSelectionModel.setValueIsAdjusting(boolean)`

### getSelectionMode

    public int getSelectionMode()

  Returns the selection mode.
  Specified by:
    `getSelectionMode` in interface `ListSelectionModel`
  Returns:
    one of the these values:
    - SINGLE_SELECTION
    - SINGLE_INTERVAL_SELECTION
    - MULTIPLE_INTERVAL_SELECTION
  See Also:
    `getSelectionMode()`

### setSelectionMode

    public void setSelectionMode(int selectionMode)

  Sets the selection mode. The default is MULTIPLE_INTERVAL_SELECTION.
  Specified by:
    `setSelectionMode` in interface `ListSelectionModel`
  Parameters:
    `selectionMode` - one of three values:
    - SINGLE_SELECTION
    - SINGLE_INTERVAL_SELECTION
    - MULTIPLE_INTERVAL_SELECTION
  Throws:
    `IllegalArgumentException` - if `selectionMode` is not one of the legal values shown above
  See Also:
    `setSelectionMode(int)`

### isSelectedIndex

    public boolean isSelectedIndex(int index)

  Description copied from interface: `ListSelectionModel`
  Returns true if the specified index is selected.
  Specified by:
    `isSelectedIndex` in interface `ListSelectionModel`

### isSelectionEmpty

    public boolean isSelectionEmpty()

  Description copied from interface: `ListSelectionModel`
  Returns true if no indices are selected.
  Specified by:
    `isSelectionEmpty` in interface `ListSelectionModel`

### addListSelectionListener

    public void addListSelectionListener(ListSelectionListener l)

  Description copied from interface: `ListSelectionModel`
  Add a listener to the list that's notified each time a change to the selection occurs.
  Specified by:
    `addListSelectionListener` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  Parameters:
    `l` - the ListSelectionListener
  See Also:
    `ListSelectionModel.removeListSelectionListener(javax.swing.event.ListSelectionListener)`, `ListSelectionModel.setSelectionInterval(int, int)`, `ListSelectionModel.addSelectionInterval(int, int)`, `ListSelectionModel.removeSelectionInterval(int, int)`, `ListSelectionModel.clearSelection()`, `ListSelectionModel.insertIndexInterval(int, int, boolean)`, `ListSelectionModel.removeIndexInterval(int, int)`

### removeListSelectionListener

    public void removeListSelectionListener(ListSelectionListener l)

  Description copied from interface: `ListSelectionModel`
  Remove a listener from the list that's notified each time a change to the selection occurs.
  Specified by:
    `removeListSelectionListener` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  Parameters:
    `l` - the ListSelectionListener
  See Also:
    `ListSelectionModel.addListSelectionListener(javax.swing.event.ListSelectionListener)`

### fireValueChanged

    protected void fireValueChanged(boolean isAdjusting)

  Notifies listeners that we have ended a series of adjustments.

### fireValueChanged

    protected void fireValueChanged(int firstIndex,
                                    int lastIndex)

  Notifies `ListSelectionListeners` that the value of the selection, in the closed interval `firstIndex`, `lastIndex`, has changed.

### fireValueChanged

    protected void fireValueChanged(int firstIndex,
                                    int lastIndex,
                                    boolean isAdjusting)

  Parameters:
    `firstIndex` - the first index in the interval
    `lastIndex` - the last index in the interval
    `isAdjusting` - true if this is the final change in a series of adjustments
  See Also:
    `EventListenerList`

### getListeners

    public EventListener[] getListeners(Class listenerType)

  Returns an array of all the listeners of the given type that were added to this model.
  Returns:
    all of the objects receiving listenerType notifications from this model
  Since:
    1.3

### setLeadAnchorNotificationEnabled

    public void setLeadAnchorNotificationEnabled(boolean flag)

  Sets the value of the leadAnchorNotificationEnabled flag.
  See Also:
    `isLeadAnchorNotificationEnabled()`

### isLeadAnchorNotificationEnabled

    public boolean isLeadAnchorNotificationEnabled()

  Returns the value of the `leadAnchorNotificationEnabled` flag. When `leadAnchorNotificationEnabled` is true the model generates notification events with bounds that cover all the changes to the selection plus the changes to the lead and anchor indices. Setting the flag to false causes a narrowing of the event's bounds to include only the elements that have been selected or deselected since the last change. Either way, the model continues to maintain the lead and anchor variables internally. The default is true.
  Returns:
    the value of the `leadAnchorNotificationEnabled` flag
  See Also:
    `setLeadAnchorNotificationEnabled(boolean)`

### clearSelection

    public void clearSelection()

  Description copied from interface: `ListSelectionModel`
  Change the selection to the empty set. If this represents a change to the current selection then notify each ListSelectionListener.
  Specified by:
    `clearSelection` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  See Also:
    `ListSelectionModel.addListSelectionListener(javax.swing.event.ListSelectionListener)`

### setSelectionInterval

    public void setSelectionInterval(int index0,
                                     int index1)

  Description copied from interface: `ListSelectionModel`
  Change the selection to be between index0 and index1 inclusive. If this represents a change to the current selection, then notify each ListSelectionListener. Note that index0 doesn't have to be less than or equal to index1.
  Specified by:
    `setSelectionInterval` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval
  See Also:
    `ListSelectionModel.addListSelectionListener(javax.swing.event.ListSelectionListener)`

### addSelectionInterval

    public void addSelectionInterval(int index0,
                                     int index1)

  Description copied from interface: `ListSelectionModel`
  Change the selection to be the set union of the current selection and the indices between index0 and index1 inclusive. If this represents a change to the current selection, then notify each ListSelectionListener. Note that index0 doesn't have to be less than or equal to index1.
  Specified by:
    `addSelectionInterval` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval
  See Also:
    `ListSelectionModel.addListSelectionListener(javax.swing.event.ListSelectionListener)`

### removeSelectionInterval

    public void removeSelectionInterval(int index0,
                                        int index1)

  Description copied from interface: `ListSelectionModel`
  Change the selection to be the set difference of the current selection and the indices between index0 and index1 inclusive. If this represents a change to the current selection, then notify each ListSelectionListener. Note that index0 doesn't have to be less than or equal to index1.
  Specified by:
    `removeSelectionInterval` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  Parameters:
    `index0` - one end of the interval.
    `index1` - other end of the interval
  See Also:
    `ListSelectionModel.addListSelectionListener(javax.swing.event.ListSelectionListener)`

### insertIndexInterval

    public void insertIndexInterval(int index,
                                    int length,
                                    boolean before)

  Insert length indices beginning before/after index. If the value at index is itself selected, set all of the newly inserted items, otherwise leave them unselected. This method is typically called to sync the selection model with a corresponding change in the data model.
  Specified by:
    `insertIndexInterval` in interface `ListSelectionModel`

### removeIndexInterval

    public void removeIndexInterval(int index0,
                                    int index1)

  Remove the indices in the interval index0,index1 (inclusive) from the selection model. This is typically called to sync the selection model width a corresponding change in the data model. Note that (as always) index0 need not be <= index1.
  Specified by:
    `removeIndexInterval` in interface `ListSelectionModel`

### setValueIsAdjusting

    public void setValueIsAdjusting(boolean isAdjusting)

  Description copied from interface: `ListSelectionModel`
  This property is true if upcoming changes to the value of the model should be considered a single event. For example if the model is being updated in response to a user drag, the value of the valueIsAdjusting property will be set to true when the drag is initiated and be set to false when the drag is finished. This property allows listeners to to update only when a change has been finalized, rather than always handling all of the intermediate values.
  Specified by:
    `setValueIsAdjusting` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  Parameters:
    `valueIsAdjusting` - The new value of the property.
  See Also:
    `ListSelectionModel.getValueIsAdjusting()`

### toString

    public String toString()

  Returns a string that displays and identifies this object's properties.
  Overrides:
    `toString` in class `Object`
  Returns:
    a `String` representation of this object

### clone

    public Object clone()
                 throws CloneNotSupportedException

  Returns a clone of this selection model with the same selection. `listenerLists` are not duplicated.
  Overrides:
    `clone` in class `Object`
  Throws:
    `CloneNotSupportedException` - if the selection model does not both (a) implement the Cloneable interface and (b) define a `clone` method.

### getAnchorSelectionIndex

    public int getAnchorSelectionIndex()

  Description copied from interface: `ListSelectionModel`
  Return the first index argument from the most recent call to setSelectionInterval(), addSelectionInterval() or removeSelectionInterval(). The most recent index0 is considered the "anchor" and the most recent index1 is considered the "lead". Some interfaces display these indices specially, e.g. Windows95 displays the lead index with a dotted yellow outline.
  Specified by:
    `getAnchorSelectionIndex` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  See Also:
    `ListSelectionModel.getLeadSelectionIndex()`, `ListSelectionModel.setSelectionInterval(int, int)`, `ListSelectionModel.addSelectionInterval(int, int)`

### getLeadSelectionIndex

    public int getLeadSelectionIndex()

  Description copied from interface: `ListSelectionModel`
  Return the second index argument from the most recent call to setSelectionInterval(), addSelectionInterval() or removeSelectionInterval().
  Specified by:
    `getLeadSelectionIndex` in interface `ListSelectionModel`
  Following copied from interface: `javax.swing.ListSelectionModel`
  See Also:
    `ListSelectionModel.getAnchorSelectionIndex()`, `ListSelectionModel.setSelectionInterval(int, int)`, `ListSelectionModel.addSelectionInterval(int, int)`

### setAnchorSelectionIndex

    public void setAnchorSelectionIndex(int anchorIndex)

  Set the anchor selection index, leaving all selection values unchanged. If leadAnchorNotificationEnabled is true, send a notification covering the old and new anchor cells.
  Specified by:
    `setAnchorSelectionIndex` in interface `ListSelectionModel`
  See Also:
    `getAnchorSelectionIndex()`, `setLeadSelectionIndex(int)`

### setLeadSelectionIndex

    public void setLeadSelectionIndex(int leadIndex)

  Sets the lead selection index, ensuring that values between the anchor and the new lead are either all selected or all deselected. If the value at the anchor index is selected, first clear all the values in the range [anchor, oldLeadIndex], then select all the values values in the range [anchor, newLeadIndex], where oldLeadIndex is the old leadIndex and newLeadIndex is the new one.

  If the value at the anchor index is not selected, do the same thing in reverse selecting values in the old range and deslecting values in the new one.

  Generate a single event for this change and notify all listeners. For the purposes of generating minimal bounds in this event, do the operation in a single pass; that way the first and last index inside the ListSelectionEvent that is broadcast will refer to cells that actually changed value because of this method. If, instead, this operation were done in two steps the effect on the selection state would be the same but two events would be generated and the bounds around the changed values would be wider, including cells that had been first cleared only to later be set.

  This method can be used in the `mouseDragged` method of a UI class to extend a selection.

  Specified by:
    `setLeadSelectionIndex` in interface `ListSelectionModel`
  See Also:
    `getLeadSelectionIndex()`, `setAnchorSelectionIndex(int)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.